/* gihuste_ciska.cc -- part of the gismu view/edit tool */
/* Copyright (C) 2000 Raphael Poss <grey.havens@earthling.net> */
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "gismu.h"

///////////////////// pu'u ciska /////////////////////////

// di'e cu stura jaknilcla be fa le datni gi'urvei
static const int gv_nilcla[] = {
	3, // rafsi1
	3, // rafsi2
	4, // rafsi3
	40, // gismu misvla
	100, // bridi
	0, 0, 0, 0, 0, // telbri misvla
	0 // pinka
};

// 
// i di'e cu ciska le gi'urvei le flecu bau le cabna stura 
// i na ciska le gismu
//
void Gihurvei::ciska(ostream& f) {
	int moi;
	for(moi = 0; moi <= (int)(Gihurvei::pinka); moi++) {
		f << '|' << _selvei[moi] << '|';
		int l = gv_nilcla[moi] - _selvei[moi].length();
		if(l > 0) f << string(l, ' ');
	};
	f << endl;
};

//
// i fi'e cu ciska le gismu kujoi le gi'urvei le flecu bau le cabna stura
//
void steciska(Gihuste& gs, ostream& f) {
	Gihuste::iterator moi;
	for(moi = gs.begin(); moi != gs.end(); moi++) {
		const string& g = moi->first;
		f << '|' << g << '|';
		
		int l = 5 - g.length();
		if(l > 0) f << string(l, ' ');
		
		// ciska le gi'urvei
		moi->second.ciska(f);
	};
};

