/* gihuste_tcidu.cc -- part of the gismu view/edit tool */
/* Copyright (C) 2000 Raphael Poss <grey.havens@earthling.net> */
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "gismu.h"

///////////////////// pu'u tcidu /////////////////////////

//
// i di'e cu tcidu pa rejka'u le flecu
// i ganai snada gi xruti la jetnu 
// 
bool rejkahu_tcidu(istream& f, string& xruti, ostream& jdefle) {
	int c = 0;
	
	while(c != '|') {
		if(!f || (c = f.get()) == EOF)
			return false;
		if(c == '\n')
			return false;
	};
	
	c = 0;
	while(c != '|') {
		if(!f || (c = f.get()) == EOF)
			return false;
		if(c == '\n') {
			jdefle << "rk_tcidu> nu tordu tcidu" << endl;
			return false;
		};
		if(c != '|') xruti += c;
	};
	return true;
};
		
//
// i di'e cu tcidu fi le flecu ca le pu'o lijporpi
//
inline void lp_facki(istream& f) { while(f && f.get() != '\n');  };

//
// i di'e cu tcidu le gi'urvei le flecu be bau le cabna stura
// i ganai snada gi xruti la jetnu
//
bool Gihurvei::tcidu(istream& f, ostream& jdefle) {
	int moi;
	string s;
	for(moi = 0; moi <= pinka; moi++) {
		s.erase();
		bool x = rejkahu_tcidu(f, s, jdefle);
		if(x) 
			_selvei[moi] = s;
		else {
			jdefle << "gv_tcidu> nu srera tcidu" << endl;
			return false;
		};
	};
	lp_facki(f);
	return true;
};

//
// i di'e cu tcidu le gi'uste le flecu be bau le cabna stura
// i ganai srera gi ciska le kajde
//
void stetcidu(Gihuste& gs, istream& f, ostream& jdefle)
{
	string gismu;
	Gihurvei gv;
	while(f) {
		gismu.erase();
		bool x;
		
		x = rejkahu_tcidu(f, gismu, jdefle);
		if(!x) 
			// flecu fanmo
			break;
		
		gv = gs[gismu];	
		x = gv.tcidu(f, jdefle);
		if(!x) 
			if(!f) {
				jdefle << "tcidu> nu catra srera tcidu" << endl;
				break;
			} else 
				continue;
			
		gs[gismu] = gv;
	};	
};

static const 
struct {
	Gihurvei::selvei_e moi;
	int krasi;
	int fanmo;
} cirsauste_selkuhe[] = 
	{ 
		{ Gihurvei::rafsi1, 6, 9 },
		{ Gihurvei::rafsi2, 10, 13 },
		{ Gihurvei::rafsi3, 14, 18 },
		{ Gihurvei::misvla, 19, 61 },
		{ Gihurvei::bridi, 61, 158 },
		{ Gihurvei::pinka, 168, 1000},
		{ Gihurvei::cirsauski, 61, 1000},
		{ (Gihurvei::selvei_e) Gihurvei::selveivau, 0, 0 }
	};

// 
// i di'e cu tcidu le gi'uste le flecu be bau le cirsau stura
// 
void stetcidu(Gihuste& gs, istream& f)
{
	char ciharlihi[1001];
	int i, k, l, s, e;
	Gihurvei::selvei_e j;
	string gismu;
	
	// le ciharlihi pamoi cu ciksi
	lp_facki(f);
	
	while(f) { 
		f.getline(ciharlihi, 1000);
		ciharlihi[1000] = '\0';
		l = ::strlen(ciharlihi);
		
		if(l <= 5) 
			continue;

		for(k = 5; 
		    k >= 0 && ciharlihi[k] == ' '; 
		    ciharlihi[k--] = '\0');
		gismu = string(ciharlihi);
		
		Gihurvei& g = gs[gismu];
		i = 0;
		while((j = cirsauste_selkuhe[i].moi) 
		         != (Gihurvei::selvei_e) Gihurvei::selveivau) {
			const int& s = cirsauste_selkuhe[i].krasi;
			const int& e = cirsauste_selkuhe[i].fanmo;
			if(l > s) {
				char v[e-s+1];
				::strncpy(v,&(ciharlihi[s]),e-s);
				v[e-s] = '\0';
				for(k = e-s-1; 
				    k >= 0 && v[k] == ' '; 
				    v[k--]='\0');
				g.selveipuhi(j, string(v));
			};
			i++;	
		};
	};
};
	
//
// i di'e cu tcidu le gihuste le re flecu pe le re stura
//
void stetcidu(Gihuste& gs, istream& csf, istream& cf, 
	      ostream& jdefle = cerr) {
	stetcidu(gs, csf);
	stetcidu(gs, cf, jdefle);
};
