/* jahostu.cc -- part of the gismu view/edit tool */
/* Copyright (C) 2000 Raphael Poss <grey.havens@earthling.net> */
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "jahostu.h"

rect jahostuste[JSkancu];

const char* galfi_skitcita = "galfi zo %s";
const char* samruhe_skitcita = "gihuste jarco je galfi";

const char* _galfi_sidju = 
"This is the gismu mini-editor.\n"
" Navigation keys are (as of ncurses++ 5.1):\n"
"\t(direction keys work as usual)\n"
"\t^F: Next field\t^B: Previous field\n"
"\t^W: Next word\t^T: Previous word\n"
"\t^A: Beginning of field\t^E: End of field\n"
"\t^I: Insert char\t^M,^J: New line\n"
"\t^V: Delete char\t^H: Delete previous char\n"
"\t^G: Delete word\t^Y: Delete line\n"
"\t^K: Clear to end of field\n"
"\n"
" Form control:\n"
"\t^X: Return to gismu list (with confirm)\n"
"\tF2: Update the gismu entry\n";


void gahirsidju_ciska(NCursesPanel& w) {
	w.printw(1,1, _galfi_sidju);
	w.frame("galfi sidju i canci ca lenu danre");
};

void preti_ciska(NCursesPanel& w) {
	w.attron(A_STANDOUT);
	w.addch('G'); 
	w.attroff(A_STANDOUT);
	w.printw("o'i i "); 
	w.attron(A_STANDOUT);
	w.addch('N');
	w.attroff(A_STANDOUT);
	w.printw("a go'i i (c)anci");
};

int preti_cipra(int c) {
	return ((c == 'g'||c == 'G') ? 0 : 
			((c == 'n' || c == 'N')? 1 : 2));
};

void jahostuste_cfari() {
	{
		rect &r = jahostuste[JS_gihuste];
		r.h = LINES-7; r.w = 24; r.y = 7; r.x = 0;
	};
	{
		rect &r = jahostuste[JS_cirsaujaho];
		r.h = 7; r.w = COLS; r.y = 0; r.x = 0;
	};
	{
		rect &r = jahostuste[JS_veirgahi];
		r.h = LINES-7; r.w = COLS-24; r.y = 7; r.x = 24;
	};
	{
		rect &r = jahostuste[JS_galfi_sidju];
		r.h = 16; r.w = 50; r.y = (LINES/2)-8; r.x = (COLS/2)-25;
	};
};
		
