/* test2.cc -- part of the gismu view/edit tool */
/* Copyright (C) 2000 Raphael Poss <grey.havens@earthling.net> */
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "ui_veirgahi.h"
#include "jahostu.h"
#include <iostream>
#include <fstream>
#include <cursesapp.h>
#include <locale.h>

class Test2 : public NCursesApplication {
	protected:
		int titlesize() const { return 1; };
		void title();
	public:
		Test2() : NCursesApplication(TRUE) {} ;
		int run();
};

void Test2::title() {
	const string title = "troci";
	const int& len = title.length();

	titleWindow->bkgd(screen_titles());
	titleWindow->addstr(0,(titleWindow->cols()-len)/2,title.data());
	titleWindow->noutrefresh();
};

int Test2::run() {
	::meta(::stdscr, TRUE);
	::setlocale(LC_ALL,"");
	
	jahostuste_cfari();
	
	ifstream f("gismu.in");
	Gihuste g;
	stetcidu(g, f);

	Gihurvei gv = g["bacru"];
	GalfiXruti x = { "bacru", gv, false };
	
	GihurveiGalfi gg(x);
	gg();

	cerr << x.baho_misvla_galfi << ":";
	gv.ciska(cerr);

	return 0;
};

static Test2 test;
