/* ui_gahicfa1.cc -- part of the gismu view/edit tool */
/* Copyright (C) 2000 Raphael Poss <grey.havens@earthling.net> */
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "ui_veirgahi.h"
#include "ui_gahiselpli.h"
#include "jahostu.h"


///////////////////// pu'u zbasu le tcita ///////////////
struct tcita_skicu {
	const int y, x;
	const char *t;
};

static const tcita_skicu tcita_liste[] =
{
   {  1, 1, "misvla:" },
   {  2, 1, "telbri misvla:" },
   {  3, 1, "telbri 1moi:" },
   {  4, 1, "telbri 2moi:" },
   {  5, 1, "telbri 3moi:" },
   {  6, 1, "telbri 4moi:" },
   {  7, 1, "telbri 5moi:" },
   {  8, 1, "bridi:" },
   {  10, 1, "pinka:" }
 };

#define tcita_kancu (sizeof(tcita_liste)/sizeof(tcita_skicu))

int GihurveiGalfi::tcita_zbasu(NCursesFormField **T)
{
	if(T) {
		int i;
		for(i = 0; i < tcita_kancu; i++)
			T[i] = new Tcita(tcita_liste[i].t,
					 tcita_liste[i].y,
					 tcita_liste[i].x);
	};
	return tcita_kancu;
};
	
//////////////////// pu'u zbasu le gahirka'u ///////////////////

struct gahirkahu_skicu {
	const rect r;
	Gihurvei::selvei_e srana;
};


static const gahirkahu_skicu gahirkahu_liste[] = 
{
   { { 1, 100,  1, 9 }, Gihurvei::misvla },
   { { 1, 100,  3, 14 }, Gihurvei::tb_mv1 },
   { { 1, 100,  4, 14 }, Gihurvei::tb_mv2 },
   { { 1, 100,  5, 14 }, Gihurvei::tb_mv2 },
   { { 1, 100,  6, 14 }, Gihurvei::tb_mv2 },
   { { 1, 100,  7, 14 }, Gihurvei::tb_mv2 },
   { { 1,  300,  9,  1 }, Gihurvei::bridi },
   { { 50, 100, 11,  1 }, Gihurvei::pinka }
};

#define gahirkahu_kancu (sizeof(gahirkahu_liste)/sizeof(gahirkahu_skicu))

int GihurveiGalfi::gahirkahu_zbasu(NCursesFormField **F)
{
	if(F) {
		int i;
		int w = width() - 2, h = height() - 2;
		Gihurvei::selvei_e s;
		for(i = 0; i < Gihurvei::selveivau; i++) Fi[i] = -1;
		for(i = 0; i < gahirkahu_kancu; i++) {
			const Gihurvei::selvei_e& s = gahirkahu_liste[i].srana;
			const int& rh = gahirkahu_liste[i].r.h;
			const int& rw = gahirkahu_liste[i].r.w;
			const int& ry = gahirkahu_liste[i].r.y;
			const int& rx = gahirkahu_liste[i].r.x;
			int ah = (ry+rh > h ? h-ry : rh);
			int aw = (rx+rw > w ? w-rx : rw);
			int h = (rh*rw - ah*aw) / aw;
			F[i] = new NCursesFormField(ah, aw, ry, rx, h);
			{
				int m = h*aw;
				char str[m + 1];
				const string &st = _x.gv.selveicpa(s);
				st.copy(str, m);
				int  l = st.length();
				str[l > m ? m : l] = '\0';
				F[i]->set_value(str);
			};
			Fi[s] = i;
		};
	};
	return gahirkahu_kancu;
			
};

