/* ui_gihurjaho.cc -- part of the gismu view/edit tool */
/* Copyright (C) 2000 Raphael Poss <grey.havens@earthling.net> */
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "ui_gihurjaho.h"
#include "jahostu.h"
#include "preti.h"

void Gihustejaho::jahorgahi()
{
	if(!gj.gismu) return;
	string gismu(gj.gismu);
	int i, n = -1, k;
	for(i=0; i < kahurkancu; i++)
		if(gismu == jahorkahuste[i].gismu) {
			n = i;
			const string s = gs[gismu].misvlacpa();
			for(k=0;k<15;jahorkahuste[i].misvla[k++]=' ')
			s.copy(jahorkahuste[i].misvla,15);
			jahorkahuste[i].misvla[15] = '\0';
			break;
		};
	gj.baho_misvla_galfi = false;
	gj.gismu = NULL;
};	

Gihustejaho::Gihustejaho(Gihuste& _gs)
		: gs(_gs), kahurkancu(_gs.size()),
		  NCursesMenu(jahostuste[JS_gihuste].h,
			      jahostuste[JS_gihuste].w,
			      jahostuste[JS_gihuste].y,
			      jahostuste[JS_gihuste].x),
		  puhidjica(false)
{
	gj.baho_misvla_galfi = false;
	gj.gismu = NULL;

	I = new NCursesMenuItem*[kahurkancu+1];
	jahorkahuste = new jahorkahu[kahurkancu];

	int j, k;
	Gihuste::iterator i;
	for(j = 0, i = gs.begin(); i != gs.end(); i++, j++) {
		const string& gismu = i->first;
		const string misvla = i->second.misvlacpa();
		{
			for(k=0;k<5;jahorkahuste[j].gismu[k++]='\0')
			jahorkahuste[j].gismu[5]='\0';
			gismu.copy(jahorkahuste[j].gismu,5);
		};
		{
			for(k=0;k<15;jahorkahuste[j].misvla[k++]=' ')
			jahorkahuste[j].misvla[15]='\0';
			misvla.copy(jahorkahuste[j].misvla,15);
		};
		I[j] = new Gihurjahokahu(jahorkahuste[j].gismu,
					 jahorkahuste[j].misvla,
					 gs, gj);
	};
	I[kahurkancu] = new NCursesMenuItem();
	InitMenu(I, TRUE, TRUE);
	frame("gihuste");
	
	melbi = new NCursesPanel(jahostuste[JS_cirsaujaho].h,
				 jahostuste[JS_cirsaujaho].w,
				 jahostuste[JS_cirsaujaho].y,
				 jahostuste[JS_cirsaujaho].x);
	cirsaujaho = new NCursesPanel(
				 jahostuste[JS_cirsaujaho].h-2,
				 jahostuste[JS_cirsaujaho].w-2,
				 jahostuste[JS_cirsaujaho].y+1,
				 jahostuste[JS_cirsaujaho].x+1);
	melbi->frame("cirsau skicu");
	melbi->show();
	cirsaujaho->show();
	return;
};
			
Gihustejaho::~Gihustejaho()
{
	cirsaujaho->hide();
	melbi->hide();
	delete cirsaujaho;
	delete melbi;
};

void Gihustejaho::On_Item_Init(NCursesMenuItem& i)
{
	string gismu(i.name());
	char line[
		(jahostuste[JS_cirsaujaho].h-2)*(jahostuste[JS_cirsaujaho].w-2)
		];
	const string& cirsauski = gs[gismu].selveicpa(Gihurvei::cirsauski);
	cirsaujaho->move(0,0);
	cirsaujaho->clrtobot();

	{
		const int m = jahostuste[JS_cirsaujaho].w-2;
		const int l = m < 97 ? m : 97;
		cirsauski.copy(line, l , 0);
		line[l] = '\n'; line[l+1] = '\0';
		cirsaujaho->attron(A_STANDOUT);
		cirsaujaho->printw(line);
		cirsaujaho->attroff(A_STANDOUT);
	};
	{
		const int m = (jahostuste[JS_cirsaujaho].w-2)*
			(jahostuste[JS_cirsaujaho].h-3);
		int l = cirsauski.length();
		if(l > 106) {
			l -= 107;
			l = l > m ? m : l;
			cirsauski.copy(line, l, 107);
			line[l] = '\n'; line[l+1] = '\0';
			cirsaujaho->move(1,0);
			cirsaujaho->printw(line);
		};
	};

	if(gj.baho_misvla_galfi)
		jahorgahi();
		
	cirsaujaho->refresh();
};

#define CTRL(x) ((x)&0x1f)

int Gihustejaho::virtualize(int c) {
	if(c == CTRL('X')) {
		ync_e p = preti("xu gihuste ninzba");
		if(p != cancel) {
			if(p == yes)
				puhidjica = true;
			else
				puhidjica = false;
			return (MAX_COMMAND+1);
		} else return 0;
	};	
	return NCursesMenu::virtualize(c);
};
