/* ui_gihurjaho.h -- part of the gismu view/edit tool */
/* Copyright (C) 2000 Raphael Poss <grey.havens@earthling.net> */
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _ui_gihurjaho_h
#define _ui_gihurjaho_h

#include <cursesm.h>
#include "gismu.h"

struct Gahirjaho {
	bool baho_misvla_galfi;
	char* gismu;
};

class Gihurjahokahu : public NCursesMenuItem {
	private:
		Gihuste& gs;
		const char* gismu;
		Gahirjaho& gj;
	public:
		inline Gihurjahokahu(const char* _gismu, 
				     const char* _misvla,
				     Gihuste& _gs,
			     	     Gahirjaho& _gj)
			: NCursesMenuItem(_gismu, _misvla),
			  gismu(_gismu),
			  gs(_gs), gj(_gj)
		{};

		bool action();
};

class Gihustejaho : public NCursesMenu {
	private:
		NCursesPanel *cirsaujaho;
		NCursesPanel *melbi;
		Gihuste& gs;
		NCursesMenuItem** I;
		typedef struct {
			char gismu[6];
			char misvla[16];
		} jahorkahu;
		jahorkahu *jahorkahuste;
		int kahurkancu;
		Gahirjaho gj;
		
		void jahorgahi();
	
	public:
		Gihustejaho(Gihuste& gs);
		~Gihustejaho();
		void On_Item_Init(NCursesMenuItem& i);
		int virtualize(int c);

		bool puhidjica;
};

#endif
