/* ui_veirgahi.cc -- part of the gismu view/edit tool */
/* Copyright (C) 2000 Raphael Poss <grey.havens@earthling.net> */
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "ui_veirgahi.h"
#include "preti.h"

#define CTRL(x) ((x)&0x1f)
#define CMD_QUIT (MAX_COMMAND+1)

int GihurveiGalfi::virtualize(int c) {
	NCursesFormField *f = current_field();
	switch(c) {
		case KEY_DC: return REQ_DEL_CHAR;
		case KEY_IC: {
			bool& i = Fins[
				(((int)f)-((int)F))
				/sizeof(NCursesFormField*)
				];
			if(i) { i = false; return REQ_OVL_MODE; }
			else { i = true; return REQ_INS_MODE; };
			};
		case KEY_F(1):	djujaho(); return 0;
		case KEY_F(2):	galfi(); return 0;
		case CTRL('X'): {
			ync_e p = preti("xu vreji ninzba");
			if(p != cancel) {
				if(p == yes)
					galfi();
				return CMD_QUIT;
			} else return 0;
			};
		default: return NCursesForm::virtualize(c);
	};
};

void GihurveiGalfi::galfi() {
	int i, j;
	for(i = 0; i < Gihurvei::selveivau; i++) 
		if(Fi[i] != -1) {
			const Gihurvei::selvei_e &s = (Gihurvei::selvei_e) i;
			NCursesFormField& f = *F[Fi[i]];
			if(f.changed()) {
				int r, c, d, o, m;
				f.info(r, c, d, d, o, d);
				m = ((r+o)*c)-1;
				const char* v = f.value();
				for(;m >= 0 && (v[m]==' '||v[m]=='\0'); m--);
				_x.gv.selveipuhi(s, string(f.value(),m+1));
			};
		};
	if(Fi[(int)Gihurvei::misvla] != -1 
	   && F[Fi[(int)Gihurvei::misvla]]->changed())
	   	_x.baho_misvla_galfi = true;
};

